org.apache.solr.handler.component

## Class ResponseBuilder

- java.lang.Object
- - org.apache.solr.handler.component.ResponseBuilder

-     public class ResponseBuilder
      extends Object

  This class is experimental and will be changing in the future.
  Since:
    solr 1.3

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ResponseBuilder.GlobalCollectionStat`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `FacetComponent.FacetInfo` | `_facetInfo`
    `List<SearchComponent>` | `components`
    `boolean` | `doExpand`
    `boolean` | `doFacets`
    `boolean` | `doHighlights`
    `boolean` | `doStats`
    `boolean` | `doTerms`
    `static String` | `FIELD_SORT_VALUES`
    `List<ShardRequest>` | `finished`
    `int` | `firstPhaseElapsedTime`
    `ResponseBuilder.GlobalCollectionStat` | `globalCollectionStat`
    `static String` | `IDS`
    `Map<String,Integer>` | `mergedGroupCounts`
    `Map<String,QueryCommandResult>` | `mergedQueryCommandResults`
    `Map<String,Collection<SearchGroup<BytesRef>>>` | `mergedSearchGroups`
    `Map<String,TopGroups<BytesRef>>` | `mergedTopGroups`
    `MergeStrategy` | `mergeFieldHandler`
    `boolean` | `onePassDistributedQuery`
    `List<ShardRequest>` | `outgoing`
    `String` | `preferredHostAddress`
    `SolrQueryRequest` | `req`
    `Map<Object,ShardDoc>` | `resultIds`
    `Map<Object,SolrDocument>` | `retrievedDocuments`
    `SolrQueryResponse` | `rsp`
    `Map<String,Map<SearchGroup<BytesRef>,Set<String>>>` | `searchGroupToShards`
    `String[]` | `shards`
    `static String` | `SHARDS`
    `int` | `shards_rows`
    `int` | `shards_start`
    `String` | `shortCircuitedURL`
    `String[]` | `slices`
    `int` | `stage`
    `static int` | `STAGE_DONE`
    `static int` | `STAGE_EXECUTE_QUERY`
    `static int` | `STAGE_GET_FIELDS`
    `static int` | `STAGE_PARSE_QUERY`
    `static int` | `STAGE_START` public static final String NUMDOCS = "nd"; public static final String DOCFREQS = "tdf"; public static final String TERMS = "terms"; public static final String EXTRACT_QUERY_TERMS = "eqt"; public static final String LOCAL_SHARD = "local"; public static final String DOC_QUERY = "dq"; *
    `static int` | `STAGE_TOP_GROUPS`
    `int` | `totalHitCount`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ResponseBuilder(SolrQueryRequest req, SolrQueryResponse rsp, List<SearchComponent> components)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDebug(Object val, String... path)`
    `void` | `addDebugInfo(String name, Object val)` Utility function to add debugging info.
    `void` | `addMergeStrategy(MergeStrategy mergeStrategy)`
    `void` | `addRequest(SearchComponent me, ShardRequest sreq)`
    `CursorMark` | `getCursorMark()`
    `NamedList<Object>` | `getDebugInfo()`
    `int` | `getFieldFlags()`
    `List<Query>` | `getFilters()`
    `GroupingSpecification` | `getGroupingSpec()`
    `Query` | `getHighlightQuery()`
    `List<MergeStrategy>` | `getMergeStrategies()`
    `CursorMark` | `getNextCursorMark()`
    `long` | `getNumberDocumentsFound()`
    `QParser` | `getQparser()`
    `Query` | `getQuery()`
    `QueryCommand` | `getQueryCommand()` Creates a SolrIndexSearcher.QueryCommand from this ResponseBuilder.
    `String` | `getQueryString()`
    `RankQuery` | `getRankQuery()`
    `SolrDocumentList` | `getResponseDocs()`
    `DocListAndSet` | `getResults()`
    `int` | `getShardNum(String shard)`
    `SortSpec` | `getSortSpec()`
    `RTimer` | `getTimer()`
    `boolean` | `grouping()`
    `boolean` | `isDebug()`
    `boolean` | `isDebugAll()`
    `boolean` | `isDebugQuery()`
    `boolean` | `isDebugResults()`
    `boolean` | `isDebugTimings()`
    `boolean` | `isDebugTrack()`
    `boolean` | `isNeedDocList()`
    `boolean` | `isNeedDocSet()`
    `void` | `setCursorMark(CursorMark cursorMark)`
    `void` | `setDebug(boolean dbg)`
    `void` | `setDebugInfo(NamedList<Object> debugInfo)`
    `void` | `setDebugQuery(boolean debugQuery)`
    `void` | `setDebugResults(boolean debugResults)`
    `void` | `setDebugTimings(boolean debugTimings)`
    `void` | `setDebugTrack(boolean debugTrack)`
    `void` | `setFieldFlags(int fieldFlags)`
    `void` | `setFilters(List<Query> filters)`
    `void` | `setGroupingSpec(GroupingSpecification groupingSpec)`
    `void` | `setHighlightQuery(Query highlightQuery)`
    `void` | `setNeedDocList(boolean needDocList)`
    `void` | `setNeedDocSet(boolean needDocSet)`
    `void` | `setNextCursorMark(CursorMark nextCursorMark)`
    `void` | `setQparser(QParser qparser)`
    `void` | `setQuery(Query query)`
    `void` | `setQueryString(String qstr)`
    `void` | `setRankQuery(RankQuery rankQuery)`
    `void` | `setResponseDocs(SolrDocumentList _responseDocs)`
    `void` | `setResult(QueryResult result)` Sets results from a SolrIndexSearcher.QueryResult.
    `void` | `setResults(DocListAndSet results)`
    `void` | `setSortSpec(SortSpec sortSpec)`
    `void` | `setTimer(RTimer timer)`
    `Query` | `wrap(Query q)` Calls `RankQuery.wrap(Query)` if there's a rank query, otherwise just returns the query.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### req

          public SolrQueryRequest req

    - #### rsp

          public SolrQueryResponse rsp

    - #### doHighlights

          public boolean doHighlights

    - #### doFacets

          public boolean doFacets

    - #### doExpand

          public boolean doExpand

    - #### doStats

          public boolean doStats

    - #### doTerms

          public boolean doTerms

    - #### mergeFieldHandler

          public MergeStrategy mergeFieldHandler

    - #### components

          public List<SearchComponent> components

    - #### FIELD_SORT_VALUES

          public static final String FIELD_SORT_VALUES

      See Also:
        Constant Field Values

    - #### SHARDS

          public static final String SHARDS

      See Also:
        Constant Field Values

    - #### IDS

          public static final String IDS

      See Also:
        Constant Field Values

    - #### STAGE_START

          public static int STAGE_START

      public static final String NUMDOCS = "nd"; public static final String DOCFREQS = "tdf"; public static final String TERMS = "terms"; public static final String EXTRACT_QUERY_TERMS = "eqt"; public static final String LOCAL_SHARD = "local"; public static final String DOC_QUERY = "dq"; *

    - #### STAGE_PARSE_QUERY

          public static int STAGE_PARSE_QUERY

    - #### STAGE_TOP_GROUPS

          public static int STAGE_TOP_GROUPS

    - #### STAGE_EXECUTE_QUERY

          public static int STAGE_EXECUTE_QUERY

    - #### STAGE_GET_FIELDS

          public static int STAGE_GET_FIELDS

    - #### STAGE_DONE

          public static int STAGE_DONE

    - #### stage

          public int stage

    - #### shards

          public String[] shards

    - #### slices

          public String[] slices

    - #### shards_rows

          public int shards_rows

    - #### shards_start

          public int shards_start

    - #### outgoing

          public List<ShardRequest> outgoing

    - #### finished

          public List<ShardRequest> finished

    - #### preferredHostAddress

          public String preferredHostAddress

    - #### shortCircuitedURL

          public String shortCircuitedURL

    - #### globalCollectionStat

          public ResponseBuilder.GlobalCollectionStat globalCollectionStat

    - #### resultIds

          public Map<Object,ShardDoc> resultIds

    - #### onePassDistributedQuery

          public boolean onePassDistributedQuery

    - #### _facetInfo

          public FacetComponent.FacetInfo _facetInfo

    - #### mergedSearchGroups

          public final Map<String,Collection<SearchGroup<BytesRef>>> mergedSearchGroups

    - #### mergedGroupCounts

          public final Map<String,Integer> mergedGroupCounts

    - #### searchGroupToShards

          public final Map<String,Map<SearchGroup<BytesRef>,Set<String>>> searchGroupToShards

    - #### mergedTopGroups

          public final Map<String,TopGroups<BytesRef>> mergedTopGroups

    - #### mergedQueryCommandResults

          public final Map<String,QueryCommandResult> mergedQueryCommandResults

    - #### retrievedDocuments

          public final Map<Object,SolrDocument> retrievedDocuments

    - #### totalHitCount

          public int totalHitCount

    - #### firstPhaseElapsedTime

          public int firstPhaseElapsedTime

  - ### Constructor Detail

    - #### ResponseBuilder

          public ResponseBuilder(SolrQueryRequest req,
                                 SolrQueryResponse rsp,
                                 List<SearchComponent> components)

  - ### Method Detail

    - #### getShardNum

          public int getShardNum(String shard)

    - #### addRequest

          public void addRequest(SearchComponent me,
                                 ShardRequest sreq)

    - #### addDebugInfo

          public void addDebugInfo(String name,
                                   Object val)

      Utility function to add debugging info. This will make sure a valid debugInfo exists before adding to it.

    - #### addDebug

          public void addDebug(Object val,
                               String... path)

    - #### isDebug

          public boolean isDebug()

    - #### isDebugAll

          public boolean isDebugAll()

      Returns:
        true if all debugging options are on

    - #### setDebug

          public void setDebug(boolean dbg)

    - #### addMergeStrategy

          public void addMergeStrategy(MergeStrategy mergeStrategy)

    - #### getMergeStrategies

          public List<MergeStrategy> getMergeStrategies()

    - #### getRankQuery

          public RankQuery getRankQuery()

    - #### setRankQuery

          public void setRankQuery(RankQuery rankQuery)

    - #### setResponseDocs

          public void setResponseDocs(SolrDocumentList _responseDocs)

    - #### getResponseDocs

          public SolrDocumentList getResponseDocs()

    - #### isDebugTrack

          public boolean isDebugTrack()

    - #### setDebugTrack

          public void setDebugTrack(boolean debugTrack)

    - #### isDebugTimings

          public boolean isDebugTimings()

    - #### setDebugTimings

          public void setDebugTimings(boolean debugTimings)

    - #### isDebugQuery

          public boolean isDebugQuery()

    - #### setDebugQuery

          public void setDebugQuery(boolean debugQuery)

    - #### isDebugResults

          public boolean isDebugResults()

    - #### setDebugResults

          public void setDebugResults(boolean debugResults)

    - #### getDebugInfo

          public NamedList<Object> getDebugInfo()

    - #### setDebugInfo

          public void setDebugInfo(NamedList<Object> debugInfo)

    - #### getFieldFlags

          public int getFieldFlags()

    - #### setFieldFlags

          public void setFieldFlags(int fieldFlags)

    - #### getFilters

          public List<Query> getFilters()

    - #### setFilters

          public void setFilters(List<Query> filters)

    - #### getHighlightQuery

          public Query getHighlightQuery()

    - #### setHighlightQuery

          public void setHighlightQuery(Query highlightQuery)

    - #### isNeedDocList

          public boolean isNeedDocList()

    - #### setNeedDocList

          public void setNeedDocList(boolean needDocList)

    - #### isNeedDocSet

          public boolean isNeedDocSet()

    - #### setNeedDocSet

          public void setNeedDocSet(boolean needDocSet)

    - #### getQparser

          public QParser getQparser()

    - #### setQparser

          public void setQparser(QParser qparser)

    - #### getQueryString

          public String getQueryString()

    - #### setQueryString

          public void setQueryString(String qstr)

    - #### getQuery

          public Query getQuery()

    - #### setQuery

          public void setQuery(Query query)

    - #### getResults

          public DocListAndSet getResults()

    - #### setResults

          public void setResults(DocListAndSet results)

    - #### getSortSpec

          public SortSpec getSortSpec()

    - #### setSortSpec

          public void setSortSpec(SortSpec sortSpec)

    - #### getGroupingSpec

          public GroupingSpecification getGroupingSpec()

    - #### setGroupingSpec

          public void setGroupingSpec(GroupingSpecification groupingSpec)

    - #### grouping

          public boolean grouping()

    - #### getTimer

          public RTimer getTimer()

    - #### setTimer

          public void setTimer(RTimer timer)

    - #### getQueryCommand

          public QueryCommand getQueryCommand()

      Creates a SolrIndexSearcher.QueryCommand from this ResponseBuilder. TimeAllowed is left unset.

    - #### wrap

          public Query wrap(Query q)

      Calls `RankQuery.wrap(Query)` if there's a rank query, otherwise just returns the query.

    - #### setResult

          public void setResult(QueryResult result)

      Sets results from a SolrIndexSearcher.QueryResult.

    - #### getNumberDocumentsFound

          public long getNumberDocumentsFound()

    - #### getCursorMark

          public CursorMark getCursorMark()

    - #### setCursorMark

          public void setCursorMark(CursorMark cursorMark)

    - #### getNextCursorMark

          public CursorMark getNextCursorMark()

    - #### setNextCursorMark

          public void setNextCursorMark(CursorMark nextCursorMark)

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.